/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <math.h>

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
SPI_HandleTypeDef hspi2;
DMA_HandleTypeDef hdma_spi2_rx;

TIM_HandleTypeDef htim1;

UART_HandleTypeDef huart2;

/* USER CODE BEGIN PV */

//#define WW (968.0*2*3.141592654f/140800)
//#define SINUS (int16_t)(16383.0f*sinf
//int16_t istab[1600]={
//SINUS(   0*WW)),SINUS(   1*WW)),SINUS(   2*WW)),SINUS(   3*WW)),SINUS(   4*WW)),SINUS(   5*WW)),SINUS(   6*WW)),SINUS(   7*WW)),SINUS(   8*WW)),SINUS(   9*WW)),

//const uint16_t dat[17600]=

char buf[100];
uint32_t irqtimcnt = 0;
uint32_t spidmahalfcnt = 0;
uint32_t spidmacnt = 0;
uint32_t halfelapsed, fullelapsed;
volatile uint8_t lowbufbusy,highbufbusy;
uint32_t ui1,ui2;

uint32_t err =0;
#define OVERRUN_ERR (1<<0)
#define DETERMI_ERR (1<<1)
#define DMA_ERR (1<<2)
#define TOOSMALL_ERR (1<<3)

#define PI (3.141592654f)
#define ZWOPI (2.0*PI)

// 16200 = 1800 * 9
// es wird ein Ton von 160000/128=1250Hz ausgegeben
// Die samplefrq beträgt 2250000 s/s
// 1/2.25e6 = 1, 1/1250=x -> 1800 samples/Welle
// Das Fenster ist 1800*9*16 breit, da gehen 9*16 Wellen rein
#define BUFLEN (14715)
uint16_t spibuf[BUFLEN];
uint16_t hugbuf[BUFLEN];

// die 6 Frequenzen
uint16_t ff[6] = {2160, 2180,2160, 2180,2160, 2180};

float ff1[2*109]; // f 2160: 14715*16/2160=109
float ff2[2*108]; // f 2180: 14715*16/2180=108
float det1,det2,det3,det4,det5,det6;
float det1,det2,det3,det4,det5,det6;
float aa1,aa2,aa3,aa4,aa5,aa6;
float bb1,bb2,bb3,bb4,bb5,bb6;
float ab1,ab2,ab3,ab4,ab5,ab6;

float rere[8],imim[8];
float divre[4],divim[4];
float divan[4],divab[4];

float re10,im10,re32,im32,rebla,imbla;

float tij,tik,tkj,tkl;

uint32_t samplerate;

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_USART2_UART_Init(void);
static void MX_DMA_Init(void);
static void MX_SPI2_Init(void);
static void MX_TIM1_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/**********************************************************/
void mischen(uint16_t f, float * rere,float * imim)
/**********************************************************/
{ int32_t k,nn,m;
  uint16_t ind,pp,s1;
  uint8_t w;

  float * tab;
  float coco,cosi,sisi,hh,hi;
  float aa,bb,ab,det;

  if(f==2160) {tab=ff1;nn=109;aa=aa1;bb=bb1;ab=ab1;det=det1;}
  if(f==2180) {tab=ff2;nn=108;aa=aa2;bb=bb2;ab=ab2;det=det2;}

  coco=0.0f;
  sisi=0.0f;
  ind=0;
  for(k=0;k<BUFLEN;k++){
	  s1=hugbuf[k];
	  pp=(1<<15);
	  for(m=0;m<16;m++){
	    // langsamer
	    //w=((s1&pp)!=0);
	    //coco += w*tab[2*ind  ];
		//sisi += w*tab[2*ind+1];

		if(s1&pp){
		   coco += tab[2*ind  ];
		   sisi += tab[2*ind+1];
		}

		ind++;
		if(ind==nn) ind=0;
		pp >>=1;
	   }
   }

   // nicht nötig
   //rere[0] =det*(aa*coco+ab*sisi);
   //imim[0] =det*(ab*coco+bb*sisi);
   rere[0] = coco;
   imim[0] = sisi;

   //bet[0] = sqrtf(hh*hh+hi*hi);
   //ang[0] = atan2f(hi,hh);
}


/**********************************************************/
void compl_mult(float rea, float ima, float reb, float imb,
		        float * reerg, float * imerg)
/**********************************************************/
{
reerg[0]=rea*reb-ima*imb;
imerg[0]=ima*reb+rea*imb;
return;
}

/**********************************************************/
void compl_div(float rea, float ima, float reb, float imb,
		        float * reerg, float * imerg)
/**********************************************************/
/* a/b                                                    */
{ float hh;
reerg[0]=rea*reb+ima*imb;
imerg[0]=ima*reb-rea*imb;
hh= reb*reb+imb*imb;
if(hh>0.0) hh=1.0/hh;
reerg[0]=reerg[0]*hh;
imerg[0]=imerg[0]*hh;
}


/**********************************************************/
void initabellen(void)
/**********************************************************/
{ int32_t k,n;
  float coco,cosi,sisi;

// f 2160
#define NNN (109)
  for(k=0;k<NNN;k++){
	  ff1[2*k  ] = (float)(cos(2.0f*PI*k/(float)NNN));
      ff1[2*k+1] = (float)(sin(2.0f*PI*k/(float)NNN));
  }

 /*
  coco =0.0f;
  sisi =0.0f;
  cosi =0.0f;
  for(k=0;k<BUFLEN*16;k++){
      n= k%NNN;
      coco += ff1[2*n  ]*ff1[2*n  ];
      sisi += ff1[2*n+1]*ff1[2*n+1];
      cosi += ff1[2*n  ]*ff1[2*n+1];
  }

  det1 = coco*sisi-cosi*cosi; // die Determinante
  //det1 = 1.0f/det1; else err |= DETERMI_ERR;
  aa1=sisi/det1;bb1=coco/det1;ab1=-cosi/det1 ;// invertierte symmetrische 2x2 Matrix [c -b ; -b a]
  */

  // richtiger Faktor ist noch 1e-5

  aa1= 0.849473326537544f;
  bb1= 0.849473326537544f;
  ab1= 0.0f;


// f 2180
#define NNN (108)
  for(k=0;k<NNN;k++){
	  ff2[2*k  ] = (float)(cos(2.0f*PI*k/(float)NNN));
      ff2[2*k+1] = (float)(sin(2.0f*PI*k/(float)NNN));
  }

  /* funzt vllt. nicht
  coco =0.0f;
  sisi =0.0f;
  cosi =0.0f;
  for(k=0;k<BUFLEN*16;k++){
      n= k%NNN;
      coco += ff2[2*n  ]*ff2[2*n  ];
      sisi += ff2[2*n+1]*ff2[2*n+1];
      cosi += ff2[2*n  ]*ff2[2*n+1];
  }
  det2 = coco*sisi-cosi*cosi; // die Determinante
  if(det2 != 0.0f) det2 = 1.0f/det2; else err |= DETERMI_ERR;
  aa2=sisi;bb2=coco;ab2=-cosi ;// invertierte symmetrische 2x2 Matrix [c -b ; -b a]
  */

  // Die gleichen. warum nur warum

  aa2= 0.849473326537546f;
  bb2= 0.849473326537546;
  ab2= 0.0f;

#undef NNN


}


/***********************************************/
uint32_t readdmaptr(void)
/***********************************************/
{volatile uint32_t aa,bb;
 while(1){
	    aa=DMA1_Channel4->CNDTR;
	    bb=DMA1_Channel4->CNDTR;
	    if(aa==bb) break;
	  }
 return (BUFLEN-aa);
}

/***********************************************/
void copydmabuf(void)
/***********************************************/
{volatile uint32_t aa;
 uint32_t k,chunk,pp,timo;
 volatile uint32_t anzchunks;
 volatile w=0;


 anzchunks=3*109;
 chunk=BUFLEN/anzchunks ; // glatt, 14715/109 = 135

 // warte bis er oben ist

 timo=0;
 while(1){
   aa=readdmaptr();
   if(aa>(BUFLEN-100)) break;
   if(timo++ > 1000*1000){err |= DMA_ERR; break;}
 }
// So kommt ein Fehler
/*
 for(k=0;k<BUFLEN;k++) {
   if(w){
      if(readdmaptr()>k) err |= OVERRUN_ERR ;
   } else {
      if(readdmaptr()<k) w=1;
   }
   hugbuf[k]=spibuf[k];
  }
*/
  ui1=readdmaptr();
  for(k=0;k<BUFLEN;k++) hugbuf[k]=spibuf[k];
  ui2=readdmaptr();

}

/***********************************************/
void goertzel(uint16_t * dat, uint32_t f,
              float * rere, float * imim)
/***********************************************/
{

 // Vorsicht, numerisch kritisch
 float q0,q1,q2;
 float cosw2;
 int32_t k,m;
 uint16_t pp;

 q1=0.0f;
 q2=0.0f;

 // Vorsicht, kleine Zahl, in double rechnen
 cosw2=(float)((double)2.0-2.0*cos((double)(2.0*PI*f/(16*BUFLEN))));
 //////////////////
 //cosw2=1e-8;

 for(k=0;k<BUFLEN;k++){
  pp=(1<<15);
  for(m=0;m<16;m++){
    q0= 2.0*q1-cosw2*q1-q2+((dat[k]&pp)>0);
    pp >>=1;
    q2=q1;
    q1=q0;
  }
 }

 //q0=2.0*cos((double)(2.0*PI*f/(16*BUFLEN)))*q1-q2;
 q0= -cosw2*q1+2.0f*q1-q2;
 q2=q1;
 q1=q0;

 // Vllt. den Sinus in
 imim[0]=(   q2*sinf(2.0*PI*f/(16*BUFLEN)));
 rere[0]=(q1-q2*cosf(2.0*PI*f/(16*BUFLEN)));

 }

/***********************************************/
void difftim (uint16_t * dat,
               float * tij,float * tik,
               float * tkj,float * tkl)
/***********************************************/
{

#define STARTF (2000)   // Startfrequenz [Hz]
#define DIFFF  (40)     // Differenzfrequnz [Hz]
#define SPEED  (343)    // m/s


    int32_t k=0;

    goertzel(dat,235,&(divre[0]),&(divim[0]));
    goertzel(dat,240,&(divre[1]),&(divim[1]));
    goertzel(dat,245,&(divre[2]),&(divim[2]));
    goertzel(dat,250,&(divre[3]),&(divim[3]));


    for(k=0;k<4;k++){  /// 2 !!
      divab[k] =  sqrtf(divre[k]*divre[k]+divim[k]*divim[k]);
      if(divab[k]>0.0f)
        divan[k] =  (180.0/PI)*atan2f(divim[k],divre[k]);
      else
        {divan[k] = 0.0f;err |= TOOSMALL_ERR;}
    }

    compl_div(divre[1],divim[1],divre[0],divim[0],&re10,&im10);
    compl_div(divre[3],divim[3],divre[2],divim[2],&re32,&im32);
    compl_div(re32,im32,re10,im10,&rebla,&imbla);

    //tij[0]=divan[0]-divan[1];

}



/***********************************************/
HAL_SPI_RxHalfCpltCallback(SPI_HandleTypeDef  hspi2)
/***********************************************/
{
  highbufbusy=1;
  spidmahalfcnt++;
}


/***********************************************/
HAL_SPI_RxCpltCallback(SPI_HandleTypeDef hspi2)
/***********************************************/
{
    lowbufbusy=1;
	spidmacnt++;
}


/************************************************************/
void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
/************************************************************/
{
	uint32_t n;
	static uint32_t m=1;// darf nicht 0 sein
	static uint32_t f0=0,f1=0,f2=0;

	irqtimcnt++;


	if (htim == &htim1 )
     {


	    //n=(m^(m<<(11-9))); // der geht
	    //n=(m^(m<<(11-2))); // der geht
	    //n=(m^(m<<(11-5))^(m<<(11-3))^(m<<(11-1))); // der geht
	    //n=(m^(m<<(11-6))^(m<<(11-5))^(m<<(11-1))); // der geht

	    //n=m^(m<<(16-15))^(m<<(16-13))^(m<<(16-4)); // der geht
	    //n=m^(m<<(17-14)); // der geht
	    //n=m^(m<<(15-14)); // der geht
	    //n=m^(m<<(6-5)); // der geht

	    //n=(n>>10)&1;
	    //m=((m<<1)|n);

		//if((irqtimcnt>>5)&1)
		//	  GPIOA->ODR |=(1<<15);
		//  else
		//	  GPIOA->ODR &=~(1<<15);

	    //f0+=(1ull<<26);
	    //f0+=((1ull<<26)*170)/176;
	    //f1+=(1ull<<26);

        /*
        if((f1%(50))==0){
                  f1=0;
	   	    	  if (GPIOC->ODR & (1<<8)) {
	   	    	    GPIOC->ODR &=~(1<<8);
	   	    	    GPIOC->ODR |= (1<<9);
     	    	  }else{
	   	    	    GPIOC->ODR |= (1<<8);
	   	    	    GPIOC->ODR &=~(1<<9);
	   	    	  }
	    }
        */

        //f1 += (int32_t)((1<<29)/((150000.0f/2)/18000.0f));
        //f0 += (int32_t)((1<<29)/((150000.0f/2)/18050.0f));
        //f1 += (int32_t)((2160.0f*2E6/(BUFLEN*16.0f))*2.0f*(1<<29)/150000.0f);
        //f2 += (int32_t)((2180.0f*2E6/(BUFLEN*16.0f))*2.0f*(1<<29)/150000.0f);
        /*
	    if((f1>>29)&1){
	   	    	  GPIOC->ODR |= (1<<8);
	   		      GPIOC->ODR &=~(1<<9);
	   				}else{
	   		      GPIOC->ODR |= (1<<9);
	   		      GPIOC->ODR &=~(1<<8);
	    }


	    if(((f2)>>(3+26))&1){
	   	    	  GPIOC->ODR |= (1<<6);
	   		      GPIOB->ODR &=~(1<<8);
	   				}else{
	   		      GPIOB->ODR |= (1<<8);
	   		      GPIOC->ODR &=~(1<<6);
	    }

      */

	  }
}

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  float reref,imimf;
  int k=0,w;
  uint32_t m,n,aa,bb;
  volatile uint32_t v1;
  int32_t tic,toc;
  int32_t lowre,lowim,highre,highim,lowphase,highphase;
  int32_t f0refloat,f0imfloat,f0anfloat,f0befloat;
  int32_t f0re,f0im,f1re,f1im,f2re,f2im;
  int32_t f3re,f3im,f4re,f4im,f5re,f5im;
  int32_t f0be,f0an,f1be,f1an,f2be,f2an;
  int32_t f3be,f3an,f4be,f4an,f5be,f5an;
  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USART2_UART_Init();
  MX_DMA_Init();
  MX_SPI2_Init();
  MX_TIM1_Init();
  /* USER CODE BEGIN 2 */

  HAL_TIM_Base_Start_IT(&htim1);

  //HAL_ADC_Start_DMA(&hadc3,(uint32_t*)adcbuf3,4096);
  //HAL_SPI_Receive_DMA (SPI_HandleTypeDef *hspi, uint8_t *pData, uint16_t Size)
  HAL_SPI_Receive_DMA (&hspi2, (uint8_t *) spibuf, (uint16_t)BUFLEN);


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  initabellen();

  w=0;
  while (1)
  {
  k++;
       if(spidmacnt>10)
       //if(w==0)
       {
         //HAL_SPI_DMAStop (&hspi2);

         //for(k=0;k<BUFLEN;k++) hugbuf[k]=spibuf[k];
         w=1;
         tic=irqtimcnt;
         copydmabuf();
         difftim (hugbuf,&tij,&tik,&tkj,&tkl);
         toc=irqtimcnt;
       }
       /*
       highbufbusy=0;
       lowbufbusy =0;
       while(highbufbusy==0);
       // lowbuf ist fertig
       tic=DMA1_Channel4->CNDTR;
       calcphase(0, &lowre, &lowim);
       lowphase=(int32_t)((36000.0/3.14159)*atan2f((float)(-lowim),(float)(lowre)));
       tic=tic-DMA1_Channel4->CNDTR;
       */

       samplerate = (int32_t)(((float)spidmacnt*BUFLEN*16*2000)/(float)irqtimcnt);

      sprintf(buf,"%d %d %d %d %d %d %d %d \r\n",
              (int32_t) (divab[0]*1.0f),
              (int32_t) (divan[0]*1.0f),
              (int32_t) (divab[1]*1.0f),
              (int32_t) (divan[1]*1.0f),
              (int32_t) (divab[2]*1.0f),
              (int32_t) (divan[2]*1.0f),
              (int32_t) (divab[3]*1.0f),
              (int32_t) (divan[3]*1.0f));
      HAL_UART_Transmit(&huart2, (uint8_t *) buf, strlen(buf), HAL_MAX_DELAY);

       sprintf(buf,"%d %d %d %d %d %d %d %d \r\n",

               (int32_t) ((180/PI)*atan2f(im10,re10)),
               (int32_t) ((180/PI)*atan2f(im32,re32)),
               (int32_t) ((180/PI)*atan2f(imbla,rebla)),
             4,5,6,7,8);
      HAL_UART_Transmit(&huart2, (uint8_t *) buf, strlen(buf), HAL_MAX_DELAY);


       sprintf(buf,"%d %d %d %d %d %d %d %d \r\n",
              ui1,
              ui2,
              err,
    		  irqtimcnt,
    		  spidmacnt,
			  toc-tic,
			  samplerate,8);
      //HAL_UART_Transmit(&huart2, (uint8_t *) buf, strlen(buf), HAL_MAX_DELAY);

      for(m=0;m<BUFLEN;m++){
    	  sprintf(buf," %d %d \r\n", m,hugbuf[m]);
          //HAL_UART_Transmit(&huart2, (uint8_t *) buf, strlen(buf), HAL_MAX_DELAY);
      }



       //sprintf(buf,"%d %d %d \r\n",k%BUFLEN,hugbuf[k%BUFLEN],spidmacnt);
      //(int32_t)(aa1*1e8),(int32_t)(bb1*1e8),(int32_t)(ab1*1e8),(int32_t)(det1));

      //if(m<aa) m=aa;
	  //sprintf(buf,"%d %d %d %d \r\n",k,m,spidmahalfcnt,spidmacnt);
	  //HAL_UART_Transmit(&huart2, (uint8_t *) buf, strlen(buf), HAL_MAX_DELAY);
	  //spibuf[0],spibuf[k%BUFLEN]);
      //sprintf(buf,"%d %d %d %d\r\n",irqtimcnt,k%BUFLEN,spibuf[k%BUFLEN],spidmacnt);
      //sprintf(buf,"%d %d %d \r\n",irqtimcnt,k%BUFLEN,spibuf[k%BUFLEN]);
      //sprintf(buf,"start %d \r\n",irqtimcnt);
      //HAL_UART_Transmit(&huart2, (uint8_t *) buf, strlen(buf), HAL_MAX_DELAY);

      //goertzel(dat,1936,&rere,&imim);
      //goertzel(dat,1936,&rere,&imim);

      //sprintf(buf,"end %d %d %d %d \r\n",irqtimcnt,(int32_t)(100.f*rere),
      //(int32_t)(100.f*imim),(int32_t)(100.0f*(180/PI)*atan2f(imim,rere)));
      //HAL_UART_Transmit(&huart2, (uint8_t *) buf, strlen(buf), HAL_MAX_DELAY);


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  RCC_OscInitStruct.PLL.PREDIV = RCC_PREDIV_DIV1;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_USART2|RCC_PERIPHCLK_TIM1;
  PeriphClkInit.Usart2ClockSelection = RCC_USART2CLKSOURCE_PCLK1;
  PeriphClkInit.Tim1ClockSelection = RCC_TIM1CLK_HCLK;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief SPI2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI2_Init(void)
{

  /* USER CODE BEGIN SPI2_Init 0 */

  /* USER CODE END SPI2_Init 0 */

  /* USER CODE BEGIN SPI2_Init 1 */

  /* USER CODE END SPI2_Init 1 */
  /* SPI2 parameter configuration*/
  hspi2.Instance = SPI2;
  hspi2.Init.Mode = SPI_MODE_MASTER;
  hspi2.Init.Direction = SPI_DIRECTION_2LINES_RXONLY;
  hspi2.Init.DataSize = SPI_DATASIZE_16BIT;
  hspi2.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi2.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi2.Init.NSS = SPI_NSS_SOFT;
  hspi2.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_16;
  hspi2.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi2.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi2.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi2.Init.CRCPolynomial = 7;
  hspi2.Init.CRCLength = SPI_CRC_LENGTH_DATASIZE;
  hspi2.Init.NSSPMode = SPI_NSS_PULSE_ENABLE;
  if (HAL_SPI_Init(&hspi2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI2_Init 2 */

  /* USER CODE END SPI2_Init 2 */

}

/**
  * @brief TIM1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM1_Init(void)
{

  /* USER CODE BEGIN TIM1_Init 0 */

  /* USER CODE END TIM1_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM1_Init 1 */

  /* USER CODE END TIM1_Init 1 */
  htim1.Instance = TIM1;
  htim1.Init.Prescaler = 0;
  htim1.Init.CounterMode = TIM_COUNTERMODE_DOWN;
  htim1.Init.Period = 36000;
  htim1.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim1.Init.RepetitionCounter = 0;
  htim1.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim1) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim1, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterOutputTrigger2 = TIM_TRGO2_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim1, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM1_Init 2 */

  /* USER CODE END TIM1_Init 2 */

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 115200;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  huart2.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart2.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * Enable DMA controller clock
  */
static void MX_DMA_Init(void)
{

  /* DMA controller clock enable */
  __HAL_RCC_DMA1_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Channel4_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel4_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel4_IRQn);

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOF_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, LD2_Pin|GPIO_PIN_15, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_6|GPIO_PIN_8|GPIO_PIN_9, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, GPIO_PIN_8, GPIO_PIN_RESET);

  /*Configure GPIO pin : B1_Pin */
  GPIO_InitStruct.Pin = B1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_FALLING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(B1_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : LD2_Pin PA15 */
  GPIO_InitStruct.Pin = LD2_Pin|GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : PC6 PC8 PC9 */
  GPIO_InitStruct.Pin = GPIO_PIN_6|GPIO_PIN_8|GPIO_PIN_9;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pin : PB8 */
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
